%bcond_without bundled_libpfm
Summary: Performance Application Programming Interface
Name: papi
Version: 5.0.1
Release: 2%{?dist}
License: BSD
Group: Development/System
URL: http://icl.cs.utk.edu/papi/
Source0: http://icl.cs.utk.edu/projects/papi/downloads/%{name}-%{version}.tar.gz
Patch8: papi-5.0.1-i686.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: ncurses-devel
BuildRequires: gcc-gfortran
BuildRequires: kernel-headers >= 2.6.32
BuildRequires: chrpath
BuildRequires: lm_sensors-devel
%if %{without bundled_libpfm}
BuildRequires: libpfm-devel
BuildRequires: libpfm-static
%endif
# Following required for net component
BuildRequires: net-tools
# Following required for inifiband component
BuildRequires: libibmad-devel
#Right now libpfm does not know anything about s390 and will fail
ExcludeArch: s390 s390x

%description
PAPI provides a programmer interface to monitor the performance of
running programs.

%package devel
Summary: Header files for the compiling programs with PAPI
Group: Development/System
Requires: papi = %{version}-%{release}
%description devel
PAPI-devel includes the C header files that specify the PAPI user-space
libraries and interfaces. This is required for rebuilding any program
that uses PAPI.

%package static
Summary: Static libraries for the compiling programs with PAPI
Group: Development/System
Requires: papi = %{version}-%{release}
%description static
PAPI-static includes the static versions of the library files for
the PAPI user-space libraries and interfaces.

%prep
%setup -q

%patch8 -p1 -b .i686

%build
%if %{without bundled_libpfm}
# Build our own copy of libpfm.
%global libpfm_config --with-pfm-incdir=%{_includedir} --with-pfm-libdir=%{_libdir}
%endif

cd src
%configure --with-perf-events \
%{?libpfm_config} \
--with-static-lib=yes --with-shared-lib=yes --with-shlib \
--with-components="appio coretemp example lmsensors lustre mx net rapl stealtime"
#components currently left out because of build configure/build issues
#--with-components="appio cuda vmware"

pushd components
#pushd cuda; ./configure; popd
pushd infiniband; %configure; popd
pushd lmsensors; \
 %configure --with-sensors_incdir=/usr/include/sensors \
 --with-sensors_libdir=%{_libdir}; \
 popd
#pushd vmware; ./configure; popd
popd

#DBG workaround to make sure libpfm just uses the normal CFLAGS
DBG="" make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
cd src
make DESTDIR=$RPM_BUILD_ROOT install

chrpath --delete $RPM_BUILD_ROOT%{_libdir}/*.so*

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig
%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_bindir}/*
%{_libdir}/*.so.*
/usr/share/papi
%doc INSTALL.txt README LICENSE.txt RELEASENOTES.txt
%doc %{_mandir}/man1/*

%files devel
%defattr(-,root,root,-)
%{_includedir}/*.h
%if %{with bundled_libpfm}
#%{_includedir}/perfmon/*.h
%endif
%{_libdir}/*.so
%doc %{_mandir}/man3/*

%files static
%defattr(-,root,root,-)
%{_libdir}/*.a

%changelog
* Fri Sep 21 2012 William Cohen <wcohen@redhat.com> - 5.0.1-2
- Correct build for i686.

* Thu Sep 20 2012 William Cohen <wcohen@redhat.com> - 5.0.1-1
- Rebase to 5.0.1 for:
  - rhbz726798: Support for Sandy Bridge in PAPI
  - rhbz785258: FP event on Sandy Bridge when HT enabled
  - rhbz743648: Support for access to various energy and perf registers via papi 
  - rhbz831751: Ivy Bridge: support PAPI 
  - rhbz740909: Allow parallel builds
  - rhbz785975: Correct use of apostrophes in PAPI documentation

* Thu Sep 08 2011 William Cohen <wcohen@redhat.com> - 4.1.3-3
- Fixes for problems found in static analysis. [736006]

* Thu Aug 25 2011 William Cohen <wcohen@redhat.com> - 4.1.3-2
- Correct CFLAGS use in build.  [705893]

* Thu Aug 25 2011 William Cohen <wcohen@redhat.com> - 4.1.3-1
- Rebase to 4.1.3. [705893]

* Thu Apr 20 2011 William Cohen <wcohen@redhat.com> - 4.1.0-5
- Correct AMD family 15H events. [635667]

* Wed Apr 13 2011 William Cohen <wcohen@redhat.com> - 4.1.0-4
- Correct number of counters for AMD family 15H. [692668]

* Thu Feb 11 2011 William Cohen <wcohen@redhat.com> - 4.1.0-3
- Add support for AMD Family 10H and 15H. [635667]

* Tue Jun 29 2010 William Cohen <wcohen@redhat.com> - 4.1.0-2
- Enable Intel westmere support. [608901]

* Tue Jun 29 2010 William Cohen <wcohen@redhat.com> - 4.1.0-1
- Rebase to papi-4.1.0 [608901]

* Fri May 21 2010 William Cohen <wcohen@redhat.com> - 4.0.0-6
- Resolves: rhbz594299 Preserve the CFLAGS from environment.

* Wed Feb 10 2010 William Cohen <wcohen@redhat.com> - 4.0.0-4
- Resolves: rhbz562935 Rebase to papi-4.0.0 (correct ExcludeArch).

* Wed Feb 10 2010 William Cohen <wcohen@redhat.com> - 4.0.0-3
- Resolves: rhbz562935 Rebase to papi-4.0.0 (bump nvr).

* Wed Feb 10 2010 William Cohen <wcohen@redhat.com> - 4.0.0-2
- correct the ctests/shlib test
- have PAPI_set_multiplex() return proper value
- properly handle event unit masks
- correct PAPI_name_to_code() to match events
- Resolves: rhbz562935 Rebase to papi-4.0.0 

* Wed Jan 13 2010 William Cohen <wcohen@redhat.com> - 4.0.0-1
- Generate papi.spec file for papi-4.0.0.
